100 REMark Dino, version for QL by Dilwyn Jones, 2022
110 dino_colour%   = 7
120 cactus_colour% = 4
130 ground_colour% = 2
140 cloud_colour%  = 255   : REMark grey stipple
150 background_col = 0     : REMark background colour
160 slowdown_steps = 50000 : REMark 1/n activity ticks
170 pany%          = 96    : REMark top left of main pan block
180 byPerCent      = 1     : REMark percentage change of slowdown delays
190 every%         = 1000  : REMark every this much of score
200 sound_on%      = 1     : REMark 0=sound off 1=sound on
210 demo_mode%     = 0     : REMark auto-jumping
220 :
230 WINDOW #0,452,202,30,15 : BORDER #0,1,255
240 WINDOW #1,452,202,30,15 : BORDER #1,1,255
250 PAPER #0,background_col : CLS #0
260 :
270 REMark load the font used for user defined graphics
280 base = ALCHP(587)
290 Install_Font : REMark can use LBYTES dino_font instead
300 CHAR_USE #0,0,base
310 :
320 DIM backg$(2,56) : REMark cactus locations
330 :
340 hiscore = 0
350 :
360 REPeat program
370   RANDOMISE
380   CLS #0 : CSIZE #0,1,0 : INK #0,2 : CHAR_INC #0,8,18
390   :
400   REMark 0=cactus 3 (top)
410   REMark 1=cactus 2 (middle)
420   REMark 2=cactus 1 (bottom)
430   FOR y = 0 TO 2 : backg$(y) = FILL$(' ',56)
440   :
450   REMark ground background line, at pany%+(3*18)-4
460   CURSOR #0,0,pany%+50
470   FOR a = 1 TO 56 : PRINT #0,CHR$(RND(168 TO 178));
480   :
490   REMark insert a couple of random cactuses to get things started
500   backg$(2,RND(30 TO 40)) = CHR$(132)
510   backg$(2,RND(46 TO 56)) = CHR$(132)
520   INK #0,4 : OVER #0,1 : CSIZE #0,1,1
530   FOR a = 0 TO 2 : CURSOR #0,0,pany%+(18*a) : PRINT #0,backg$(a);
540   OVER #0,0
550   :
560   gap% = RND(10 TO 20) : REMark columns blank before a cactus
570   cactus_wide = 0      : REMark 1, 2 or 3 cactuses in a row
580   cactus_high = 0      : REMark 1, 2 or 3 character height cactus
590   cactus_run% = 0      : REMark how far across a cactus is being drawn (1/2/3)
600   dinobasey% = pany%+36      : REMark dinosaur 'ground level'
610   dinoy%     = dinobasey%    : REMark dino moves up from here
620   score      = 0             : REMark score is simply one point per step
630   cloudy%    = RND(27 TO 48) : REMark somewhere above cactus
640   :
650   counter% = 0 : REMark dino animation frame counter
660   ticker   = 0 : REMark speed control counter
670   jumping% = 0 : REMark <>0 for dino jumping (+ve=up, -ve=down)
680   :
690   REMark title and score bar
700   AT #0,0,10 : STRIP #0,80 : INK #0,7 : PRINT #0,' DINO ';
710   STRIP #0,background_col
720   AT #0,0,27 : PRINT #0,'HI '&FILL$('0',5-LEN(hiscore))&hiscore;
730   :
740   REMark place a random cloud to get things started
750   rn = RND(1 TO 5) : REMark avoids Turbo error
760   SELect ON rn
770     =1 : cloud_colour% = 7
780     =2 : cloud_colour% = 56
790     =3 : cloud_colour% = 63
800     =4 : cloud_colour% = 248
810     =5 : cloud_colour% = 255
820   END SELect
830   CURSOR #0,8*RND(10 TO 50),cloudy% : CSIZE #0,1,0 : INK #0,cloud_colour%
840   IF RND(1 TO 2) = 1 THEN
850     PRINT #0,CHR$(181)&CHR$(182);
860   ELSE
870     PRINT #0,CHR$(183)&CHR$(184);
880   END IF
890   INK #0,7 : CSIZE #0,1,1
900   cloud_gap% = RND(10 TO 20)
910   cloud_run% = 0 : cloud_wide = 0
920   slowdown   = slowdown_steps
930   :
940   IF demo_mode% = 1 THEN
950     REMark 1=show that demo mode (auto-jumping) is engaged
960     CURSOR #0,0,180 : CSIZE #0,1,1 : INK #0,7 : PRINT #0,'Demo Mode On ';
970   END IF
980   :
990   REPeat game
1000     :
1010     REMark --- show dino ---
1020     OVER #0,-1 : CURSOR #0,32,dinoy% : INK #0,dino_colour%
1030     PRINT #0,CHR$(128+(counter% MOD 4));
1040     :
1050     REMark speed control - ignore (slowdown-1) passes of the loop
1060     REMark or use a 'suspend' type command if you have one
1070     IF slowdown > 0 THEN
1080       REPeat wait
1090         ticker = ticker + 1
1100         IF ticker < slowdown THEN NEXT wait
1110         ticker = 0 : EXIT wait
1120       END REPeat wait
1130     END IF
1140     :
1150     key = CODE(INKEY$)
1160     SELect ON key
1170       =27    : REMark Esc
1180         OVER #0,0 : CURSOR #0,0,180 : CSIZE #0,1,1 : EXIT game
1190       =10,32 : REMark jump
1200         IF jumping% = 0 AND demo_mode% = 0 THEN
1210           jumping% = -1 : dinoy% = dinobasey% : dy% = 18
1220           IF sound_on% : BEEP 100,10
1230         END IF
1240       =CODE('P'),CODE('p') : REMark pause
1250         OVER #0,0 : AT #0,9,0 : CLS #0,3 : PRINT #0,'PAUSED'; : CURSEN #0
1260         k$ = INKEY$(-1) : CURDIS #0 : AT #0,9,0 : CLS #0,3
1270         IF k$ = CHR$(27) THEN EXIT game
1280         IF demo_mode% = 1 THEN PRINT #0,'Demo Mode On '; : ELSE CLS #0,3
1290         CURDIS #0 : OVER #0,-1
1300       =CODE('D'),CODE('d') : REMark demo-mode (auto-jumping) toggle
1310         demo_mode% = NOT demo_mode%
1320         OVER #0,0 : CURSOR #0,0,180 : CSIZE #0,1,1 : INK #0,7
1330         IF demo_mode% = 1 THEN PRINT #0,'Demo Mode On '; : ELSE CLS #0,3
1340         OVER #0,-1
1350     END SELect
1360     :
1370     REMark --- erase dino before panning ---
1380     CURSOR #0,32,dinoy% : INK #0,dino_colour%
1390     PRINT #0,CHR$(128+(counter% MOD 4)); : OVER #0,0
1400     :
1410     REMark --- detect dino striking anything ---
1420     y% = (dinobasey%-dinoy%) DIV 18
1430     IF y% < 3 THEN
1440       IF backg$(2-y%,5) <> ' ' THEN
1450         REMark struck something
1460         IF sound_on% : BEEP 5000,0,50,50,1,0,0
1470         OVER #0,-1 : CURSOR #0,32,dinoy% : INK #0,dino_colour%
1480         PRINT #0,CHR$(128+(counter% MOD 4)); : REMark show dino
1490         FOR a = 1 TO 10 : BLOCK #0,10,18,32,dinoy%,7 : PAUSE 10
1500         CURSOR #0,0,180 : OVER #0,0
1510         rn = RND(1 TO 3)
1520         SELect ON rn
1530           =1 : PRINT #0,'Ouch. ';
1540           =2 : PRINT #0,'Oops. ';
1550           =3 : PRINT #0,'Oh dear. ';
1560         END SELect
1570         EXIT game
1580       END IF
1590     END IF
1600     :
1610     IF jumping% <> 0 THEN
1620       REMark --- move dino to next position ---
1630       IF jumping% = -1 THEN
1640         REMark downward
1650         dinoy% = dinobasey% - 72*(SIN(RAD(dy%)))
1660         dy% = dy% + 18
1670         IF dy% = 90 THEN jumping% = 1 : REMark change direction
1680       ELSE
1690         REMark upward
1700         dinoy% = dinobasey% - 72*(SIN(RAD(dy%)))
1710         dy% = dy% - 18
1720         IF dy% = 0 THEN jumping% = 0 : dinoy% = dinobasey%
1730       END IF
1740     ELSE
1750       IF demo_mode% = 1 THEN
1760         REMark demo-mode - look if there is a cactus ahead
1770         IF backg$(2,10) <> ' ' THEN
1780           REMark start to auto-jump
1790           jumping% = -1 : dinoy% = dinobasey% : dy% = 18
1800           IF sound_on% : BEEP 100,10
1810         END IF
1820       END IF
1830     END IF
1840     :
1850     REMark --- pan the running cactus display array leftward ---
1860     REMark --- pan area height is 4 x 18 pixels -4 (overlap) ---
1870     INK #0,cactus_colour% : CURSOR #0,0,pany%
1880     CHAR_INC #0,8,68 : PAN #0,-8,3 : CHAR_INC #0,8,18
1890     FOR y = 2 TO 0 STEP -1 : backg$(y) = backg$(y,2 TO 56)&' '
1900     :
1910     REMark add any extra objects to right of background array
1920     REMark decrement the count until next cactus(es)
1930     IF gap% > 0 THEN
1940       gap% = gap% - 1
1950       IF gap% = 0 THEN
1960         cactus_run% = 1 : REMark how far are we across a cactus?
1970         cactus_wide = RND(1 TO 3) : REMark cactus width 1-3
1980         cactus_high = RND(1 TO 3) : REMark cactus height 1-3
1990       END IF
2000     END IF
2010     :
2020     IF cactus_run% > 0 THEN
2030       REMark add a cactus to the right
2040       SELect ON cactus_high
2050         =1 : REMark 1 character high cactus
2060              base_char = 131+(cactus_wide=2)+(3*(cactus_wide=3))
2070              backg$(2,56) = CHR$(base_char+cactus_run%)
2080         =2 : REMark 2 character high cactus
2090              base_char = 137+(cactus_wide=2)+(3*(cactus_wide=3))
2100              backg$(1,56) = CHR$(base_char+cactus_run%)
2110              backg$(2,56) = CHR$(base_char+6+cactus_run%)
2120         =3 : REMark 3 character high cactus
2130              base_char = 149+(cactus_wide=2)+(3*(cactus_wide=3))
2140              backg$(0,56) = CHR$(base_char+cactus_run%)
2150              backg$(1,56) = CHR$(base_char+6+cactus_run%)
2160              backg$(2,56) = CHR$(base_char+12+cactus_run%)
2170       END SELect
2180       cactus_run% = cactus_run% + 1
2190       IF cactus_run% > cactus_wide THEN
2200         gap% = RND(10 TO 20) : REMark start a new gap between cactuses
2210         cactus_run% = 0 : cactus_high = 0 : cactus_wide = 0 : REMark reset
2220       END IF
2230     END IF
2240     :
2250     REMark --- show updated cactus and ground display ---
2260     :
2270     REMark --- first show moving ground... ---
2280     CURSOR #0,440,pany%+50 : INK #0,ground_colour% : OVER #0,1
2290     CSIZE #0,1,0 : PRINT #0,CHR$(RND(168 TO 178)); : CSIZE #0,1,1
2300     INK #0,cactus_colour%
2310     :
2320     REMark --- then show cactuses part of array ---
2330     FOR y = 2 TO 0 STEP -1
2340       CURSOR #0,440,pany%+(18*y) : PRINT #0,backg$(y,56);
2350     END FOR y
2360     OVER #0,0
2370     :
2380     REMark handle the score
2390     score = score + 1
2400     IF score > 99999 THEN score = 0 : REMark wrap around 5 digits
2410     INK #0,7 : AT #0,0,40 : PRINT #0,FILL$('0',5-LEN(score))&score;
2420     :
2430     IF every% > 0 THEN
2440       REMark speed up slightly as score gets higher (if set to do so)
2450       IF (score MOD every%) = 0 THEN
2460         slowdown = slowdown - (slowdown * byPerCent/100)
2470       END IF
2480     END IF
2490     :
2500     REMark increment dino frame counter
2510     counter% = counter% + 1 : IF counter% > 3 THEN counter% = 0
2520     :
2530     REMark --- handle clouds, once every 4 frames ---
2540     IF (counter% MOD 4) = 0 THEN
2550       CURSOR #0,0,cloudy% : CHAR_INC #0,8,36 : PAN #0,-8,3 : CHAR_INC #0,8,18
2560       cloud_gap% = cloud_gap% - 1
2570       IF cloud_gap% = 0 THEN
2580         REMark time for a new cloud
2590         cloud_run% = 1 : REMark how far across cloud
2600         cloud_wide = RND(1 TO 3) : REMark cloud width 1-3
2610         cloud_high = RND(0 TO 1) : REMark cloud height 0-1
2620         cloudyy%   = cloudy% + RND(0 TO 26-(9*cloud_high))
2630         REMark select cloud colour stipple at random
2640         rn = RND(1 TO 5)
2650         SELect ON rn
2660           =1 : cloud_col% = 7
2670           =2 : cloud_col% = 56
2680           =3 : cloud_col% = 63
2690           =4 : cloud_col% = 248
2700           =5 : cloud_col% = 255
2710         END SELect
2720         SELect ON cloud_wide
2730           =1 : REMark small cloud/yellow sun (yellow only in hi-colour mode)
2740                IF RND(1 TO 10) = 10 THEN
2750                  REMark this 'cloud' is a small sun
2760                  cloud_base_char = 190 : cloud_high = 0 : cloud_col% = 6
2770                ELSE
2780                  cloud_base_char = 178 + (RND > .5) : REMark small cloud
2790                END IF
2800           =2 : cloud_base_char = 180+(2*(RND>.5))
2810           =3 : cloud_base_char = 184+(3*(RND>.5))
2820         END SELect
2830       END IF
2840       :
2850       IF cloud_run% > 0 THEN
2860         REMark add a cloud/sun to the right
2870         CURSOR #0,55*8,cloudyy% : INK #0,cloud_col% : CSIZE #0,1,cloud_high
2880         PRINT #0,CHR$(cloud_base_char+cloud_run%); : INK #0,7
2890         cloud_run% = cloud_run% + 1
2900         IF cloud_run% > cloud_wide THEN
2910           cloud_gap% = RND(10 TO 20) : cloud_run% = 0 : cloud_wide = 0
2920         END IF
2930       END IF
2940       :
2950     END IF
2960   END REPeat game
2970   :
2980   REMark set print position BEFORE arriving here
2990   PRINT #0,'Game over. Another game Y/N?';
3000   CURSEN #0 : k$ = INKEY$(-1) : CURDIS #0
3010   IF NOT (k$ == 'y') THEN PRINT #0,'N '; : EXIT program
3020   IF score > hiscore THEN hiscore = score
3030   :
3040 END REPeat program
3050 :
3060 CHAR_USE #0,0,0 : REMark reset fount
3070 CSIZE #0,0,0    : CHAR_INC #0,6,10 : REMark back to normal size
3080 RECHP base      : REMark deallocate heap area
3090 STOP
3100 :
3110 DEFine PROCedure Install_Font
3120   LOCal offset,read_data,byte
3130   REMark install user defined graphics font as Font#2 for channel 0
3140   RESTORE
3150   READ fl : REMark file length
3160   base = ALCHP(fl) : offset = 0
3170   REPeat read_data
3180     IF EOF : EXIT read_data
3190     READ byte
3200     POKE base+offset,byte
3210     offset = offset + 1
3220   END REPeat read_data
3230 END DEFine Install_Font
3240 :
3250 REMark font data: length,lowest char,number of chars
3260 DATA 587,127,64
3270 REMark font pattern values
3280 DATA 56,68,92,100,92,68,56,0,0,12,26,159,188,189,254,112,72,108,12,26,95,188,188,255,112,72,68
3290 DATA 12,26,159,188,189,254,112,72,40,12,26,95,188,191,252,112,72,136,24,219,219,219,222,254,120,24,24
3300 DATA 1,99,99,99,115,63,31,3,3,128,198,198,206,252,240,192,192,192,0,8,28,28,28,30,15,7,0
3310 DATA 24,60,60,60,63,63,252,252,60,0,56,56,240,224,0,0,0,0,24,24,24,26,27,27,27,91,219
3320 DATA 1,3,99,99,99,99,99,99,99,128,192,192,192,192,204,204,204,252,0,32,112,112,112,112,112,112,112
3330 DATA 24,60,60,60,60,60,60,60,60,0,0,4,14,14,14,28,56,112,219,219,219,251,123,63,30,24,24
3340 DATA 99,99,115,63,15,3,3,3,3,248,192,192,192,192,192,192,192,192,56,56,28,15,3,0,0,0,0
3350 DATA 60,61,63,63,254,252,60,60,60,224,192,128,0,0,0,0,0,0,24,24,24,216,216,216,216,219,219
3360 DATA 1,3,3,3,3,3,3,3,3,128,192,198,198,198,198,198,198,198,0,0,1,3,3,3,3,3,65
3370 DATA 24,60,60,189,191,191,188,252,252,0,0,0,128,128,0,2,7,7,219,219,219,219,223,222,216,216,216
3380 DATA 99,99,99,99,99,99,99,99,99,198,198,198,198,206,252,240,192,192,224,224,224,224,227,227,227,227,113
3390 DATA 60,60,60,61,61,63,191,252,252,7,199,199,199,199,199,135,7,7,219,251,123,27,31,30,24,24,24
3400 DATA 99,127,63,3,3,3,3,3,3,192,192,192,192,192,192,192,192,192,127,31,0,0,0,0,0,0,0
3410 DATA 252,252,255,63,60,60,60,60,126,14,30,252,240,0,0,0,0,0,0,0,255,0,0,0,0,0,0
3420 DATA 0,0,255,0,32,0,0,0,0,0,0,255,0,0,1,0,0,0,56,68,131,0,0,0,0,0,0
3430 DATA 60,66,129,0,0,0,4,0,0,0,0,129,66,60,0,0,0,0,0,0,195,60,0,0,0,0,0
3440 DATA 0,126,129,0,0,0,0,0,0,0,124,131,0,0,0,0,64,0,0,0,255,0,0,0,0,0,16
3450 DATA 0,0,129,66,60,0,192,0,2,0,0,0,24,102,129,126,0,0,0,0,0,24,126,255,126,0,0
3460 DATA 7,8,16,96,128,128,127,0,0,224,16,8,6,1,1,255,0,0,7,15,31,127,255,255,127,0,0
3470 DATA 224,240,248,254,255,255,255,0,0,0,0,3,6,8,48,64,80,143,0,60,66,133,0,0,0,0,255
3480 DATA 0,0,0,192,36,90,1,2,252,0,0,0,3,36,88,128,128,127,0,60,66,133,64,32,0,0,255
3490 DATA 0,0,192,96,144,12,18,2,255,145,66,24,60,189,60,24,66,137
